<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) PHP-Fusion Inc
| https://www.phpfusion.com/
+--------------------------------------------------------+
| Filename: youtube_bbcode_include.php
| Author: Core Development Team (coredevs@phpfusion.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
defined('IN_FUSION') || exit;

if (isset($_COOKIE[COOKIE_PREFIX."youtube_enabled"])) {
	$html = '<div class="embed-responsive embed-responsive-16by9"><iframe class="embed-responsive-item" src="https://www.youtube.com/embed/\3" allowfullscreen rel="nofollow noopener noreferrer"></iframe></div>';
	$html .= '<p class="text-center"><button type="button" class="btn btn-danger btn-sm m-t-10" onclick="unsetYTCookie()"><i class="far fa-eye-slash"></i> '.$locale['bb_youtube_block'].'</button></p>';
}
else {	
	$html = '<div class="border border-danger rounded p-10 mb-5 bg-warning text-dark">';
	$html .= '<i class="fab fa-youtube"></i> <strong>'.$locale['bb_youtube_plugin_name'].'</strong><br />'.$locale['bb_youtube_is_blocked'].'<br />';
	$html .= '<p class="text-center"><button type="button" class="btn btn-secondary btn-sm m-t-10" onclick="setYTCookie()"><i class="far fa-eye"></i> '.$locale['bb_youtube_unblock'].'</button> <a class="btn btn-primary btn-sm m-t-10" href="https://www.youtube.com/watch?v=\3" target="_blank" rel="nofollow noopener noreferrer"><i class="fab fa-youtube-square"></i> '.$locale['bb_youtube_newwindow'].'</a></p>';
	$html .= '<small>'.$locale['bb_youtube_unblock_hints'].'</small></div>';
}

if(!defined('YOUTUBE_ENABLER')) {
	define('YOUTUBE_ENABLER', TRUE); // prevents multiple outputs
	$expires = date('D, d-M-'.(date("Y")+1).' H:i:s');
	add_to_footer('
	<script>
		function setYTCookie() {
			var expires = "expires='.$expires.' GMT";
			document.cookie = "'.COOKIE_PREFIX.'youtube_enabled=1;"+expires+";path=/;SameSite=Lax";
			window.location.reload(true);
		}

		function unsetYTCookie() {
			var expires = "expires=Thu, 01-Jan-1970 00:00:01 GMT";
			document.cookie = "'.COOKIE_PREFIX.'youtube_enabled=;"+expires+";path=/;SameSite=Lax";
			window.location.reload(true);
		}
	</script>
	');
}

$text = preg_replace('#\[youtube\](http:|https:)?(\/\/www.youtube\.com\/watch\?v=|\/\/youtu\.be\/)?(.*?)\[/youtube\]#si', $html, $text);

