<?php
/*-------------------------------------------------------+
| PHPFusion Content Management System
| Copyright (C) PHP Fusion Inc
| https://phpfusion.com/
+--------------------------------------------------------+
| Filename: admin.php
| Author: RobiNN
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once '../../maincore.php';
require_once THEMES.'templates/admin_header.php';

pageaccess('LG');

$locale = fusion_get_locale('', LG_LOCALE);

add_to_title($locale['lg_title']);

add_breadcrumb(['link' => INFUSIONS.'legal/admin.php'.fusion_get_aidlink(), 'title' => $locale['lg_title']]);

opentable($locale['lg_title']);

$allowed_section = ['privacy-policy', 'cookie-policy', 'terms-of-service', 'imprint'];
$_GET['section'] = isset($_GET['section']) && in_array($_GET['section'], $allowed_section) ? $_GET['section'] : 'imprint';

$tab['title'][] = $locale['lg_03a'];
$tab['id'][]    = 'imprint';
$tab['title'][] = $locale['lg_02'];
$tab['id'][]    = 'privacy-policy';
$tab['icon'][]  = '';
$tab['title'][] = $locale['lg_03'];
$tab['id'][]    = 'cookie-policy';
$tab['icon'][]  = '';
$tab['title'][] = $locale['lg_01'];
$tab['id'][]    = 'terms-of-service';
$tab['icon'][]  = '';

echo opentab($tab, $_GET['section'], 'legaladmin', TRUE, 'nav-tabs');
switch ($_GET['section']) {
    case 'imprint':
        require_once 'admin/imprint.php';
        break;
    case 'privacy-policy':
        require_once 'admin/pp.php';
        break;
    case 'cookie-policy':
        require_once 'admin/cp.php';
        break;
    case 'terms-of-service':
        require_once 'admin/tos.php';
        break;
}
echo closetab();

closetable();

require_once THEMES.'templates/footer.php';
