<?php
/*-------------------------------------------------------+
| PHPFusion Content Management System
| Copyright (C) PHP Fusion Inc
| https://phpfusion.com/
+--------------------------------------------------------+
| Filename: legal.php
| Author: RobiNN
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once __DIR__.'/../../maincore.php';

if (!defined('LEGAL_EXISTS')) {
    redirect(BASEDIR.'error.php?code=404');
}

require_once THEMES.'templates/header.php';
require_once LEGAL.'templates/legal.tpl.php';

$locale = fusion_get_locale('', LG_LOCALE);

$text = $locale['lg_04'];
$title = $locale['lg_title'];

$_GET['page'] = isset($_GET['page']) && in_array($_GET['page'], ['privacy-policy', 'cookie-policy', 'terms-of-service', 'imprint']) ? stripinput($_GET['page']) : '';

if (!empty($_GET['page'])) {
    if ($_GET['page'] != 'terms-of-service') {
		$data = dbarray(dbquery("SELECT * FROM ".DB_LEGAL." WHERE legal_type = '".((string) $_GET['page'])."' AND ".in_group('legal_language', LANGUAGE)));
	}
	else {
		$data = array();
		$data['legal_type'] = 'terms-of-service';
		$data['legal_text'] = fusion_get_settings('license_agreement');
	}

    if (!empty($data['legal_text'])) {
        $text = parse_textarea($data['legal_text'], TRUE, FALSE, TRUE, IMAGES, TRUE);

        switch ($data['legal_type']) {
            case 'privacy-policy':
                $title = $locale['lg_02'];
                break;
            case 'cookie-policy':
                $title = $locale['lg_03'];
                break;
			case 'terms-of-service':
                $title = $locale['lg_01'];
                break;
			case 'imprint':
                $title = $locale['lg_03a'];
                break;
        }
    }
	else {
		redirect(BASEDIR.'error.php?code=404');
		exit;
	}
}

set_title($title);

render_legal($text, $title);

require_once THEMES.'templates/footer.php';
