<?php
/*-------------------------------------------------------+
| PHPFusion Content Management System
| Copyright (C) PHP Fusion Inc
| https://phpfusion.com/
+--------------------------------------------------------+
| Filename: rss_feeds_panel.php
| Author: Core Development Team
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
defined('IN_FUSION') || exit;

include_once INCLUDES."infusions_include.php";

// Feed-URL des RSS-Feeds
$feed_url = 'https://feeds.t-online.de/rss/internet';

// In welcher Datei soll der Cache abgelegt werden?
$feedcache_path = __DIR__.'/cache/feed.html';

// Wie alt in Sekunden darf der Cache sein? (1800 s entsprechen einer halben Stunde)
$feedcache_max_age = 1;

// Wie viele Einträge sollen angezeigt werden?
$max_entries = 6;

opentable("News - präsentiert von T-online.de");

if(!file_exists($feedcache_path) or filemtime($feedcache_path) < (time() - $feedcache_max_age)) {
  $xml = simplexml_load_string(file_get_contents($feed_url));
  $feed_content = '<div class="row equal-height">
  ';
  
  $entries = $xml->channel->item;
  $counter = 0;
  //$feed_content .= '<ul>';
  
  foreach($entries as $root) {
    $counter++;
    // Ausgabe nach x Einträgen beenden:
    if($counter > $max_entries) {
      break;
    }
	$feed_content .= '<div class="col-xs-12 col-sm-6 col-md-6 col-lg-6 m-0 p-15 p-t-0 p-b-0">
	<div class="item panel img-responsive p-10">
	';
    $date = date('d.M.Y', strtotime($root->pubDate));
    // Anreißertext:
    $description = $root->description;
    $feed_content .= '<div class="panel-header"><a href="'.htmlspecialchars($root->link).'" title="'.htmlspecialchars($date).'" target="_blank">'.htmlspecialchars($root->title).'</a></div>
	<div class="panel-content">'.nl2br(trimlink($description,300)).'</div>';
	$feed_content .= '
	<div class="clearfix pull-right"><a class="btn btn-default" href ="'.htmlspecialchars($root->link).'">Mehr lesen  <i class="far fa-arrow-alt-circle-right"></i></a></div>
	</div>
	</div>
	';
  }
  $feed_content .= '</div>
  '.PHP_EOL;
  
  echo $feed_content;
  file_put_contents($feedcache_path, $feed_content);
} else {
  echo file_get_contents($feedcache_path);
}

closetable();