<?php
/*-------------------------------------------------------+
| PHPFusion Content Management System
| Copyright (C) PHP Fusion Inc
| https://phpfusion.com/
+--------------------------------------------------------+
| Filename: weblinks_admin.php
| Author: Core Development Team
| Screenshot Mod: Krelli (Systemweb.de, Krelli.com)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once __DIR__ .'/../../maincore.php';
require_once THEMES.'templates/admin_header.php';

// check/update for screenshot mod
$check = dbquery("SELECT * FROM `".DB_SETTINGS_INF."` WHERE `settings_name` = 'links_screenshots_enabled' AND `settings_inf` = 'weblinks';");
$rows = dbrows($check);
if ($rows == 0) {
	$result = dbquery("INSERT INTO `".DB_SETTINGS_INF."` (`settings_name`, `settings_value`, `settings_inf`) VALUES ('links_screenshots_enabled', '0', 'weblinks');");
	$result = dbquery("ALTER TABLE `".DB_WEBLINKS."` ADD `weblink_screenshot` BLOB NULL DEFAULT NULL AFTER `weblink_language`;");
}

// new function for generation of weblinks screenshots
function generateWebthumb($id,$url) {
	$url = "https://www.googleapis.com/pagespeedonline/v5/runPagespeed?url=".urlencode($url)."&screenshot=true";
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0");
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 60);
	curl_setopt($ch, CURLOPT_TIMEOUT, 60);

	$result = curl_exec($ch);
	$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

	if ($httpcode>=200 && $httpcode<300) {
		$json_a = json_decode($result, true);
		$screenshot = $json_a['lighthouseResult']['audits']['final-screenshot']['details']['data'];
		if($screenshot) {
			$result = dbquery("UPDATE ".DB_WEBLINKS." SET 
			weblink_screenshot='".$screenshot."'
			WHERE weblink_id='".$id."';
			");
			return true;
		}
		else { return false; }
	}
	return false;
}

require_once WEBLINKS_CLASSES."autoloader.php";
PHPFusion\Weblinks\WeblinksServer::weblinksAdmin()->displayAdmin();
require_once THEMES.'templates/footer.php';
