<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) PHP-Fusion Inc
| https://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: redirect.php
| Author: André Krell (systemweb.de)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
header("Expires: Sat, 05 Nov 2005 00:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

require_once __DIR__.'/maincore.php';

$settings = fusion_get_settings();

if (!IsSet($_GET['link']) OR empty($_GET['link'])) {
    redirect(BASEDIR.'index.php');
}

$locale = fusion_get_locale();
$locale = fusion_get_locale('', LOCALE.LOCALESET.'redirect.php');

$target = urldecode($_GET['link']);

// block forbidden external linking (hotlinking)
if ($target == "" || !IsSet($_COOKIE[COOKIE_PREFIX.'lastvisit']) || $_COOKIE[COOKIE_PREFIX.'lastvisit'] > (time() - 10) || substr_count($target, 'http') > 1) {
	header("HTTP/1.1 301 Moved Permanently");
	header("Location: ".(!empty($_SERVER['HTTPS']) ? "https://" : "http://").$_SERVER['SERVER_NAME']);
	exit;
}

// testlog
/*$fp = @fopen ("./redirects.log", "a");
@fwrite($fp,date("d.M.Y - H:i:s").", ".$_SERVER['REMOTE_ADDR']." - ".(IsSet($_SERVER['HTTP_REFERER']) && $_SERVER['HTTP_REFERER']!="" ? "Referer: ".$_SERVER['HTTP_REFERER'] : "kein Referer")." - Ziel: ".$target."\r\n");
@fclose($fp);*/

if(strpos($target, rtrim($settings['siteurl'], " \/\n\r\t\v\x00"))!==false) { 
	header("HTTP/1.1 301 Moved Permanently");
	header("Location: ".$target);
	exit;
}

require_once INCLUDES."output_handling_include.php";

require_once THEME."theme.php";
if (file_exists(INCLUDES."header_includes.php")) {
    require_once INCLUDES."header_includes.php";
}
require_once INCLUDES."theme_functions_include.php";

header("Content-Type: text/html; charset=".$locale['charset']."");
echo "<!DOCTYPE html>\n";
echo "<html lang='".$locale['xml_lang']."' dir='".$locale['text-direction']."'>\n";
echo "<head>\n";
echo "<title>".$settings['sitename']."</title>\n";
echo "<meta charset='".$locale['charset']."'>\n";
echo "<meta name='referrer' content='never'>\n";
echo "<meta name='description' content='".$settings['description']."'>\n";
echo "<meta name='url' content='".$settings['siteurl']."'>\n";
echo "<meta name='keywords' content='".$settings['keywords']."'>\n";
echo "<meta name='image' content='".$settings['siteurl'].$settings['sitebanner']."'>\n";

if (defined('BOOTSTRAP') || defined('BOOTSTRAP4')) {
    if (defined('BOOTSTRAP4')) {
        echo '<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">';
        echo '<link rel="stylesheet" href="'.INCLUDES.'bootstrap/bootstrap4/css/bootstrap.min.css">';
    } else {
        echo '<meta http-equiv="X-UA-Compatible" content="IE=edge">';
        echo '<meta name="viewport" content="width=device-width, initial-scale=1">';
        echo '<link rel="stylesheet" href="'.INCLUDES.'bootstrap/bootstrap3/css/bootstrap.min.css">';

        if ($locale['text-direction'] == 'rtl') {
            echo '<link rel="stylesheet" href="'.INCLUDES.'bootstrap/bootstrap3/css/bootstrap-rtl.min.css">';
        }
    }
}

if (defined('ENTYPO')) {
    echo "<link rel='stylesheet' href='".INCLUDES."fonts/entypo/entypo.min.css'>\n";
}

if (defined('FONTAWESOME')) {
    echo "<link rel='stylesheet' href='".INCLUDES."fonts/font-awesome-5/css/all.min.css'>\n";
}

if (!defined('NO_DEFAULT_CSS')) {
    echo "<link rel='stylesheet' href='".THEMES."templates/default.min.css?v=".filemtime(THEMES.'templates/default.min.css')."'>\n";
}

$theme_css = file_exists(THEME.'styles.min.css') ? THEME.'styles.min.css' : THEME.'styles.css';
echo "<link rel='stylesheet' href='".$theme_css."?v=".filemtime($theme_css)."'>\n";

if (defined('BOOTSTRAP')) {
    $user_theme = fusion_get_userdata('user_theme');
    $theme_name = $user_theme !== 'Default' ? $user_theme : $settings['theme'];
    $theme_data = dbarray(dbquery("SELECT theme_file FROM ".DB_THEME." WHERE theme_name='".$theme_name."' AND theme_active='1'"));

    if (!empty($theme_data)) {
        echo "<link rel='stylesheet' href='".THEMES.$theme_data['theme_file']."'>\n";
    }
}

echo render_favicons(defined('THEME_ICON') ? THEME_ICON : IMAGES.'favicons/');

echo "<script src='".INCLUDES."jquery/jquery.min.js'></script>\n";
echo "</head>\n";


echo "<body style='margin: 10px;'>\n";
echo "<div class='m-t-20 jumbotron text-center'>\n";
echo "<img class='img-responsive center-x' src='".BASEDIR.$settings['sitebanner']."' alt='".$settings['sitename']."' /><br />\n";
echo "<div class='container well clearfix m-t-20 p-20 p-b-0'>\n";
echo "<p>".$locale['external_links_redirect']."<br />\n<small><strong>".$target."</strong></small></p>\n<hr />\n";
echo "<small>".$locale['external_links_disclaimer']."</small><br />";
echo "<a href='".BASEDIR.$settings['opening_page']."' class='btn btn-danger' onClick='JavaScript:self.close(); return false;'>".$locale['external_link_break']."</a>&nbsp;&nbsp;\n";
echo "<a href='".$target."' rel='nofollow noopener noreferrer' class='btn btn-success'>".$locale['external_link_proceed']."</a>\n";
echo "<br /><br />\n";
echo "</div>\n";
echo "</div>";


echo \PHPFusion\OutputHandler::$pageFooterTags;

if (defined('BOOTSTRAP') || defined('BOOTSTRAP4')) {
    if (defined('BOOTSTRAP4')) {
        echo '<script src="'.INCLUDES.'bootstrap/bootstrap4/js/bootstrap.bundle.min.js"></script>';
    } else {
        echo '<script src="'.INCLUDES.'bootstrap/bootstrap3/js/bootstrap.min.js"></script>';
    }
}
echo "</body>\n";
echo "</html>";

$output = ob_get_contents();
if (ob_get_length() !== FALSE) {
    ob_end_clean();
}
$output = handle_output($output);
echo $output;
if ((ob_get_length() > 0)) {
    ob_end_flush();
}
